<?php

function db_addPartie( $csv ){

  echo $csv;
  return;

  $data=array(
    'member:'.get_0($member),
    'location:'.$location,
    'tags:'.$tags,
    'url:'.$url,
    'orderlist:'.preg_replace('/\r\n/',PHP_EOL,$orderlist),
    'price:'.number_format( $price,8,'.','' ),
    'shipping:'.number_format( $shipping,8,'.','' ),
    'currency:'.$currency
  );
  $datastring=implode(PHP_EOL,$data);
  $m=db_getFromMembersById( $member );

  $F=new FaircoinAddress($m['fair_address'],false);
  if( !$F->verifymessage($datastring , $signature ) ){
    // signature invalid
    return array( 'success' => false, 'message' => 'signature could not be verified!', 'd' => [ $m['fair_address'], $datastring, $signature ] );
  }

  $db=new db;

  $signature_hex=bin2hex( base64_decode($signature) );
  $sql = "INSERT INTO stargate_list ( member, location, tags, url, orderlist, price, shipping, currency, signature ) VALUES ( ".$member.",'".$location."','".$tags."','".$url."','".$orderlist."',".$price.", ".$shipping.",'".$currency."', 0x".$signature_hex.")";

  if ( $db->query($sql) === TRUE) {
      // success
      $result=array( 'success' => true, 'message' => 'order verified and added successfully!', 'data' => db_getFromListBySignature($signature));
  } else {
      // check if already exists
      $row=db_getFromListBySignature($signature);
      if($row){
        $result=array( 'success' => true, 'message' => 'order already exists and successfully verified!', 'data' => $row );
      } else {
        $result=array( 'success' => false, 'message' => 'sql error!' );
      }
  }

  unset($db);
  return $result;
}
function db_addErgebnisse( $csv, $secret ){

  $C=preg_split('/,/',$csv);

  if( !is_numeric($C[6]) || !is_numeric($C[7]) ){
    return db_removeErgebnisse( $csv, $secret );
  }
  $C[1]='"'.$C[1].'"';
  $C[3]='"'.$C[3].'"';
  $C[4]='"'.$C[4].'"';
  $C[5]='"'.$C[5].'"';

  $user=db_checkSecret($secret);
  if( empty( $user ) ) return false;

  $C[]=$user['id'];

  $csv=implode($C,',');

  $db=new db;
  $sql = "REPLACE INTO Ergebnisse VALUES ( ".$csv." )";

  if ( $db->query( $sql ) === TRUE) {
      // success
      $result=array( 'success' => true, 'message' => 'Spieltag erfolgreich hinzugefügt!', 'data' => [] );
  } else {
      echo 'SQL-Error: '.$sql.'<br>';
  }

  unset($db);
  return $result;
}
function db_addSpieler( $csv, $secret ){

  $C=preg_split('/,/',$csv);
  $C[1]='"'.$C[1].'"';
  $C[2]='0x'.$C[2];
  $C[4]='"'.$C[4].'"';
  unset($C[3]);
  unset($C[6]);
  unset($C[7]);
  unset($C[8]);
  unset($C[9]);
  unset($C[10]);
  unset($C[11]);
  unset($C[12]);
  unset($C[13]);

  $C[]=SAISON_NOW;
  $user=db_checkSecret($secret);
  if( empty( $user ) ) return false;

  $C[]=$user['id'];

  $csv=implode($C,',');

  $db=new db;

  $sql = "REPLACE INTO Spieler VALUES ( ".$csv." )";

  if ( $db->query( $sql ) === TRUE) {
      // success
      $result=array( 'success' => true, 'message' => 'Spieltag erfolgreich hinzugefügt!', 'data' => [] );
  } else {
      echo 'SQL-Error: '.$sql.'<br>';
  }

  unset($db);
  return $result;
}
function db_addStatistik( $csv, $secret ){

  $C=preg_split('/,/',$csv);
  if( $C[3] == '0' ) return;
  $C[2]='"'.$C[2].'"';
  $C[4]='0x'.$C[4];
  unset($C[5]);

  $user=db_checkSecret($secret);
  if( empty( $user ) ) return false;

  $ergebnis=db_getFromErgebnisseByMID($C[0]);
  if( empty( $ergebnis ) || $C[0] == '0' ) return;

  $C[]=$user['id'];

  $csv=implode($C,',');

  $db=new db;

  $sql = "REPLACE INTO Statistik VALUES ( ".$csv." )";

  if ( $db->query( $sql ) === TRUE) {
      // success
      $result=array( 'success' => true, 'message' => 'Statistik erfolgreich hinzugefügt!', 'data' => [] );
  } else {
      echo 'SQL-Error: '.$sql.'<br>';
  }

  unset($db);
  return $result;
}

function db_removeErgebnisse( $csv, $secret ){

  $C=preg_split('/,/',$csv);

  $user=db_checkSecret($secret);
  if( empty( $user ) ) return false;

  $db=new db;
  $sql = "DELETE FROM Ergebnisse WHERE
          saison=".$C[0]."
          AND runde='".$C[1]."'
          AND spieltag=".$C[2]."
          AND H='".$C[4]."'
          AND A='".$C[5]."'";

  if ( $db->query( $sql ) === TRUE) {
      // success
      $result=array( 'success' => true, 'message' => 'Ergebnis erfolgreich entfernt!', 'data' => [] );
  } else {
      echo 'SQL-Error: '.$sql.'<br>';
  }

  unset($db);
  return $result;
}

function db_checkSecret($secret){

  $db=new db;

  $sql = 'SELECT * FROM User WHERE secret="'.$secret.'"';

  $result = $db->query($sql);

  $row = $result->fetch_assoc();

  unset($db);
  return $row;

}
function db_getFromTeams(){

  $db=new db;

  $sql = 'SELECT * FROM Teams';
  $result = $db->query($sql);

  $ROW=Array();

  while( $row = $result->fetch_assoc() ){
    $ROW[]=$row;
  }

  unset($db);
  return $ROW;

}
function db_getFromSpieler(){

  $db=new db;

  $sql = 'SELECT * FROM Spieler';
  $result = $db->query($sql);

  $ROW=Array();

  while( $row = $result->fetch_assoc() ){
    $row['id']=bin2hex($row['id']);
    $ROW[]=$row;
  }

  unset($db);
  return $ROW;

}
function db_getFromErgebnisse(){

  $db=new db;

  $sql = 'SELECT * FROM Ergebnisse';
  $result = $db->query($sql);

  $ROW=Array();

  while( $row = $result->fetch_assoc() ){
    $ROW[]=$row;
  }

  unset($db);
  return $ROW;

}
function db_getFromErgebnisseByMID($mid){

  $db=new db;

  $sql = 'SELECT * FROM Ergebnisse WHERE MID='.$mid;
  $result = $db->query($sql);

  $ROW=Array();

  while( $row = $result->fetch_assoc() ){
    $ROW[]=$row;
  }

  unset($db);
  return $ROW;

}
function db_getFromStatistikBySaison($saison){

  $db=new db;

  /*
  $sql = 'SELECT Statistik.MID, Statistik.SpielerID, Spieler.name, Spieler.nt, Spieler.age, Teams.id, SUM(Statistik.Tore) AS "Tore", SUM(Statistik.Assists) AS "Assists", SUM(Statistik.Zpos - Statistik.Zneg) AS "Zwkbilanz" FROM Statistik
          INNER JOIN Ergebnisse ON Ergebnisse.MID = Statistik.MID
          LEFT JOIN Spieler     ON Spieler.id = Statistik.SpielerID
          LEFT JOIN Teams       ON Teams.id = Spieler.teamID
          WHERE Ergebnisse.saison = '.$saison.'
          GROUP BY SpielerID, MID';
  */
  $sql='SELECT Statistik.MID, Statistik.SpielerID, Spieler.name, Spieler.nt, Spieler.age, Spieler.age_saison, Teams.id, Statistik.Tore, Statistik.Assists, Statistik.Zpos, Statistik.Zneg, Statistik.Zpos - Statistik.Zneg AS "Zwk" FROM Statistik
          INNER JOIN Ergebnisse ON Ergebnisse.MID = Statistik.MID
          LEFT JOIN Spieler     ON Spieler.id = Statistik.SpielerID
          LEFT JOIN Teams       ON Teams.id = Spieler.teamID
          WHERE Ergebnisse.saison = '.$saison.'
          GROUP BY SpielerID, MID';

  $result = $db->query($sql);

  $ROW=Array();

  while( $row = $result->fetch_assoc() ){
    $row['SpielerID']=bin2hex($row['SpielerID']);
    $ROW[]=$row;
  }

  unset($db);
  return $ROW;

}

?>
